Тёмный

Longest Common Subsequence - Dynamic Programming - Leetcode 1143 

NeetCode
Подписаться 811 тыс.
Просмотров 260 тыс.
50% 1

🚀 neetcode.io/ - A better way to prepare for Coding Interviews
🐦 Twitter: / neetcode1
🥷 Discord: / discord
🐮 Support the channel: / neetcode
Coding Solutions: • Coding Interview Solut...
Dynamic Programming Playlist: • House Robber - Leetco...
Tree Playlist: • Invert Binary Tree - D...
Linked List Playlist: • Reverse Linked List - ...
Problem Link: neetcode.io/pr...
0:00 - Read the problem
4:23 - Read the problem
14:05 - Read the problem
leetcode 1143
This question was identified as an interview question from here: github.com/xiz...
#sorted #array #python

Опубликовано:

 

12 сен 2024

Поделиться:

Ссылка:

Скачать:

Готовим ссылку...

Добавить в:

Мой плейлист
Посмотреть позже
Комментарии : 199   
@NeetCode
@NeetCode 3 года назад
🚀 neetcode.io/ - I created a FREE site to make interview prep a lot easier, hope it helps! ❤
@Qwantopides
@Qwantopides Год назад
Absolute legend! Recently I have been realizing how extremely helpful people in the competitive coding community are. Quite shocking to be honest. Like you! How much effort you have put in to help out others is amazing!
@thecomputerman1
@thecomputerman1 2 года назад
Damn, I looked at the problem from your list of 75 problems as I am preparing for an interview, the first time I looked at the problem, I went black, I had a 15 minute timer, I just didn't know what to do and how to proceed. not even close. never could comprehend that a 2D matrix could be a way to look at problems like that, You just opened up my thought process. I have more than 10+ years of experience but I never attempted competitive programming (I'm from a systems engineering background (devops/sre sort) and never required these sorts of problems to be solved, neither in real life nor in any interview). Thanks a ton, Dude for all your efforts. Really appreciate it.
@audioplatform6299
@audioplatform6299 4 месяца назад
If the computer man cannot how can lesser mortals like some of us could😢?
@PhanNghia-fk5rv
@PhanNghia-fk5rv 4 месяца назад
Ty for ur sharing, i have an westion what bring u here to leetcode as u said that u dont need it for job
@chaitanyaswaroop7669
@chaitanyaswaroop7669 3 месяца назад
@@PhanNghia-fk5rv He said he never had any interviews or required to solve problems in the past. But as said in the first line, he is preparing for an interview now
@alokesh985
@alokesh985 2 года назад
Great solution, as always, but even if you solve this starting at the first cell of the table, it would still be a bottom-up approach. Tabulation is called bottom-up because we are starting from a smaller problem and we are building up to the larger problem's solution. Memoization is called a top-down approach because we start from the larger problem and break into smaller problems using recursion (something like recursiveFunction(n - 1)). So, basically, tabulation DP, which is what is done here, is bottom-up. Memoization DP is top-down.
@ashok2089
@ashok2089 Месяц назад
Thanks!
@ku-1119
@ku-1119 2 года назад
Thanks for the explanation. It has been exremely helpful as usual!! Note to others: when initialising dp in the beginning, doing dp = [[0] * (len(text2) + 1)] * (len(text1) + 1) does NOT work because this creates "len(text1) + 1" number of REFERENCES, so updating one array will update everything else. You can try and print the dp array and see for yourself. I found this explanation from the LC discuss section, and didn't realise this in my solution and I was stumped on why my answer was incorrect!
@zactamzhermin1434
@zactamzhermin1434 2 года назад
If you want to avoid double for loop list comprehension you can only do that in the inner loop so it should look like this instead: dp = [[0] * (len(text2) + 1) for _ in range(len(text1) + 1)]
@itachid
@itachid Год назад
Thank you. Was wondering the same.
@jahleelmurray2826
@jahleelmurray2826 7 месяцев назад
Oh woww thank you man I was so perplexed 🤣
@quinnlangford6521
@quinnlangford6521 2 месяца назад
thanks for this
@paulreilley5439
@paulreilley5439 Год назад
I didn't understand this concept until you explained it. As an educator I can confidently say fantastic job! I'm working on this concept on Codecademy and it took me a minute to realize that you set the no character columns as bottom and right, whereas Codecademy does them as left and top. Seeing it done both ways and the subtle differences in the code was extremely helpful to fully comprehend the purpose of this exercise. Thank you!
@amardeepbhowmick3614
@amardeepbhowmick3614 3 года назад
Your channel has the best content on Dynamic Programming, both from the theory as well as the coding perspective!
@jonaskhanwald566
@jonaskhanwald566 3 года назад
Bro please upload videos daily. I'm very dependent on you. Your videos are the best to understand.
@ritikajaiswal3824
@ritikajaiswal3824 2 года назад
can you tell me whether watching the solutions helped you in doing good in DSA?
@varunshrivastava2706
@varunshrivastava2706 2 года назад
@@ritikajaiswal3824 Try to solve the problem for 30min if you are unable to solve it then look for a video solution. Problem Solving is a skill that will take a lot of time to master!!!!
@balajivenkatraman2991
@balajivenkatraman2991 2 года назад
@@ritikajaiswal3824 What an arrogant statement that is, we can do a math in our mind if it comes to algorithm certain formula/approach needed. Certainly his video helped me to improve a lot and able to apply the concept in other problems too.
@mohammadammech7934
@mohammadammech7934 2 года назад
@@ritikajaiswal3824 it helped me a lot, in both DS and algorithms
@srinadhp
@srinadhp 3 года назад
Wow! That is something! Had to watch couple of times to understand the very difficult concept.. but as usual, you made it so simmple with your impeccable explanation. Amazing stuff! Thanks a lot!
@fatbubble123
@fatbubble123 2 года назад
This is the most incredible explanation of 2D Dynamic Programing solutions I have ever seen. Props to NeetCode for that *Fantastic* visual representation
@sajinkowser7228
@sajinkowser7228 2 года назад
From trivial questions to niche ones, every single video is quality - great stuff man!
@albertd7658
@albertd7658 Год назад
We could use a full-size 2d grid, but all we really need it 2 rows with the length of the x-axis, in this case, text2. - Time complexity: O(len(text1) * len(text2)) - Space complexity: O(len(text2)) class Solution: def longestCommonSubsequence(self, text1: str, text2: str) -> int: prevRow = [0] * (len(text2) + 1) for r in range(len(text1) - 1, -1, -1): curRow = [0] * (len(text2) + 1) for c in range(len(text2) - 1, -1, -1): if text1[r] == text2[c]: curRow[c] = prevRow[c + 1] + 1 else: curRow[c] = max(curRow[c + 1], prevRow[c]) prevRow = curRow return prevRow[0]
@PC-pr8gi
@PC-pr8gi 2 года назад
you make it look so SIMPLE !!! In fact after the visualization/explanation, the code just comes naturally to one's mind.
@julesrules1
@julesrules1 2 года назад
I've watched a bunch of videos to understand this question, and this one is by far the most intuitive to me. I can't thank you enough. 👏👏👏👏👏
@josecabrera7947
@josecabrera7947 2 года назад
dude, I never write comments but thank you !!! I hope you know that you have made an impact on several people's lives for the better.
@rohitkumaram
@rohitkumaram 2 года назад
It is still your solution only: but I find normal iteration easier than reverse, it can depend person to person: dp = [[0 for j in range(len(text2)+1)] for i in range(len(text1)+1)] for i in range(1,len(text1)+1): for j in range(1,len(text2)+1): if text1[i-1]==text2[j-1]: dp[i][j] = 1 + dp[i-1][j-1] else: dp[i][j] = max(dp[i-1][j], dp[i][j-1]) return dp[len(text1)][len(text2)]
@NeetCode
@NeetCode 2 года назад
Yeah, I'll probably do future problems with normal iteration
@rohitkumaram
@rohitkumaram 2 года назад
@@NeetCode hey, you replied me thankyou so much would like to connect more. Since I want to become a faang engineer.
@CostaKazistov
@CostaKazistov 2 года назад
💯agree - forward iteration is much easier to follow
@ritvikgaur3444
@ritvikgaur3444 2 года назад
Hi Rohit , can you explain that why both for loop are not giving string index out of range error as we are doing (len(text1)+1) which will add extra 1 space at last which cannot be iterated at it is not defined.
@rohitkumaram
@rohitkumaram 2 года назад
@@ritvikgaur3444 dp is defined with length +1, and while iterating string we are iterating always i-1, and j-1, so it will always be 1 less than last limit
@kevincai4249
@kevincai4249 3 года назад
My favorite channel on youtube!!! Thanks a lot for the great work, it helps me so much! Continue to solve more leetcode problems and help more people to understand it.
@ukuduck531
@ukuduck531 2 года назад
Couldn't appreciate more, really. My daily routine is basically, continue watching your 75 question playlist, try to solve the problem by myself, then watch your brilliant explanation no matter if I pass it or not. I just completed this 2D DP problem, which I previously feared I couldn't think it through, without watching your code. This feels so good! Simply, thank you!!
@danielsun716
@danielsun716 Год назад
FYI, I did a space compression. The memory complexity is O(n). def longestCommonSubsequence(self, text1: str, text2: str) -> int: dp = [0] * (len(text2) + 1) for i in range(len(text1) - 1, -1, -1): nextDP = [0] * (len(text2) + 1) for j in range(len(text2) - 1, -1, -1): if text1[i] == text2[j]: nextDP[j] = 1 + dp[j + 1] else: nextDP[j] = max(dp[j], nextDP[j + 1]) dp = nextDP return dp[0]
@castorseasworth8423
@castorseasworth8423 Год назад
Genius
@luis-azanza
@luis-azanza 2 года назад
I love the way you explain complicated problems like this one. There's just some many different approaches! Thank you so much :)
@kunal_chand
@kunal_chand 2 года назад
The best visual explanation for this problem. I finally understand why do we take the 2D DP array. Because every cell in the array holds information to compare every possible subsequence
@il5083
@il5083 Год назад
Using a top-bottom recursive approach will make the code easier to read in my opinion. The drawing walkthrough helped me to get a more concrete understanding, thanks a lot!
@kaushiktd
@kaushiktd 3 года назад
I have been struggling to get my mind around this until found this video. Thanks 🙏
@ruthviks
@ruthviks Год назад
Hey, buddy. I have been watching your videos for a while and learning a lot. I really have to say thank you for the time and efforts you put on. You are doing a great job.
@Dhruvbala
@Dhruvbala Месяц назад
I find this problem easier to understand in terms of a decision tree / recursive DP, then bottom up. And this can be optimized fairly easily to O(n) memory complexity.
@anandkulkarni2111
@anandkulkarni2111 5 дней назад
good one!! one of the best explanations I have heard for why the solution of this problem works!! i.e diagonal (when matching chars ) vs max of side way movements during mismatch
@tune6000
@tune6000 Год назад
Why does my code not work when I initialize my DP matrix like this: mat = [ [0] * (N2 + 1)] * (N1 + 1) , but it does work when I initialize like this: mat = [[ 0 for j in range(N2 + 1)] for i in range(N1 + 1)] ? N1 is len(text1) and N2 is len(text2)
@AlejandroRuiz-pd6ci
@AlejandroRuiz-pd6ci 3 года назад
Dude NeetCode you are life savior, keep it up bro
@capooti
@capooti 3 года назад
great video, thanks as usual. In this case I find it easier to iterate the rows and columns in regular (and not reversed) order.
@snake1625b
@snake1625b 2 года назад
wasnt expecting the code to be that short. amazing video btw, long your intuition in the beginning
@xhenryx14
@xhenryx14 2 года назад
Thank you so much, I have had this problem and I never understood the solution until now! They never taught this algorithm in my DS and Algo class
@bprincepandey
@bprincepandey 2 года назад
The best explanation of LCS I have seen. Thanks man.
@itsjustramblings
@itsjustramblings 7 месяцев назад
Very well explained in a simple and direct way 👍. I initially saw this as inverse of levenshtein algorithm...without the initial values populated in each dimension since we are looking for the max common subsequence instead of no of changes required to turn one string to another. If you change the max comparison to min comparison and start from the beginning you can find the minimum changes required to turn one string to another. This algorithm will work if you iterate from beginning as well. It took me 3-4 hrs to understand levenshtein first time i came across.
@celbelle4182
@celbelle4182 10 месяцев назад
I am really struggling to wrap my head around coding, but your explanation was so engaging and simple. Thank you so much.
@thevagabond85yt
@thevagabond85yt Год назад
Since the problem is symmetric (solve start to end or end to start) you can also code a program which starts from 0th index... see this java code : class Solution { public int longestCommonSubsequence(String text1, String text2) { int m= text1.length(), n= text2.length(); int [][] match= new int[m+1][n+1]; for(int i=0; i
@demaxl732
@demaxl732 3 месяца назад
you deserve everything this world has to offer
@city8390
@city8390 3 года назад
Great explanation to understand! Thanks.
@meowmaple
@meowmaple 2 года назад
Will the bottom up approach work if you start from the start of the substrings instead of at the end? Great video btw!
@bereketyisehak5584
@bereketyisehak5584 Год назад
yeap it does, but the length is save at the last element in the array.
@raminessalat9803
@raminessalat9803 Год назад
Hi, Great video. There is one improvement in terms of space complexity. You really don't need to cache all that table. You just need the three values of dp[i+1][j] , dp[i][j+1] and dp[i+1][j+1] you can update these values as you go up and that's it. you dont need more memory. I thought it might be helpful to add it.
@igx_s2745
@igx_s2745 10 месяцев назад
You mean to declare 3 variables, lets say, diagonal = 0, right = 0, down = 0 ?
@yogeshkhatri4555
@yogeshkhatri4555 2 года назад
Man you are a good teacher ! Just found out about your channel and subscribed
@thatguy14713
@thatguy14713 2 года назад
Is it possible to implement a recursive w/ caching solution to this problem, similar to the other DP problems you have solved? If so, do you think you could describe the approach?
@tnmyk_
@tnmyk_ 2 года назад
Your explanation made the solution so easy to understand! Thanks a lot for making this video, it was veryyy helpful! Keep up the good work!
@mehershrishtinigam5449
@mehershrishtinigam5449 2 года назад
This was such a simple explanation! Thank you!
@zaidziad1456
@zaidziad1456 3 года назад
Clear and simple, thanks a lot.
@prachibari731
@prachibari731 2 года назад
You are AWESOME!! I wish I had known about your channel earlier.
@amitvyas7905
@amitvyas7905 Месяц назад
The top down also works. That (top down) was the first thing that came to my mind when I first saw the question and when I saw this video, I got confused but when I saw the leetcode solutions then I found out I was right.
@Cld136
@Cld136 3 года назад
Another great tutorial. Much thanks!
@rishabhsharma6193
@rishabhsharma6193 2 года назад
superb explanation as always... but can we just do it with 1D dp for last row then update it as we move forward, just like we did in unique paths?
@dipesh1401
@dipesh1401 2 года назад
this is the best video on this problem on yt
@adityakulkarni2764
@adityakulkarni2764 2 года назад
Your solution is great but how did u find out that this problem is actually 2D DP problem?
@abhilakshmaheshwari9360
@abhilakshmaheshwari9360 2 года назад
You are a saviour man!!! If you have a solution for a question, I always visit yours first (not to mention I never need to visit any other video/blog after that)
@matthewsponagle5143
@matthewsponagle5143 2 года назад
You are great at explaining these problems! thank you.
@stringjourney
@stringjourney 3 месяца назад
Once the logic explanation was done...code looks easy peasy Great work.
@amankassahunwassie587
@amankassahunwassie587 Год назад
It can be solved in memory complexity of O(n). check my code. row = [0]*(len(text2)+1) for i in range(len(text1)-1, -1,-1): newrow = [0]*(len(text2)+1) for j in range(len(text2)-1, -1, -1): if text1[i]==text2[j]: newrow[j] = 1 + row[j+1] else: newrow[j] = max(row[j], newrow[j+1]) row = newrow return row[0]
@sashikshik
@sashikshik 7 месяцев назад
RU: Меня просто угнетает тот факт, что я, не зная алгоритма более двух часов пытался решить эту задачу и не смог EN: I’m simply depressed by the fact that, without knowing the algorithm, I tried to solve this problem for more than two hours and could not
@harshithdesai9989
@harshithdesai9989 7 месяцев назад
As usual, its a wonderful explanation of the bottom up approach. Thank you so much!!!
@duanjianxiong2785
@duanjianxiong2785 2 года назад
How did you come up with the idea of using the 2D grid?
@NeetCode
@NeetCode 2 года назад
Mainly just from experience (i def didn't come up with it myself). This is a textbook 2D dynamic programming problem, once you understand it, many other problems become easier.
@medsabkhi
@medsabkhi 2 года назад
thank you for your content Neetcode, it's really helpful, i'm following your 75 leetcode question on a daily basis. I appreciate your work, sending love from North Africa
@binpan3602
@binpan3602 2 года назад
I felt like top down is more intuitive to me in this case?
@johnpaul4301
@johnpaul4301 27 дней назад
The top down is almost always more intuitive. Especially for 2D dp problems
@shankaranarayana6568
@shankaranarayana6568 2 года назад
Its possible to optimise this further by calculating the values in the cells we need only right?
@WdnUlik2no
@WdnUlik2no 2 года назад
That's exactly what I was thinking as well; it seems like it would be possible to only have two rows
@TheStefanV
@TheStefanV 2 года назад
Yes
@shaggypeach
@shaggypeach Год назад
This was great really made me understood the concept. Thank you! Is there one for three strings?
@yinglll7411
@yinglll7411 3 года назад
Thank you so much! learned a lot from your channel
@vantran321
@vantran321 2 года назад
Holy crap your stuff really helped me out man
@CharlesGreenberg000
@CharlesGreenberg000 5 месяцев назад
How would you then use the DP table to obtain the actual best sequence? I suppose you start at the top left. If you find same symbol, move diagonally down. Otherwise take the max of bottom or right. Does that always work?
@hwang1607
@hwang1607 Год назад
i think this is easy to do after learning the solution but there was no way I would be able to figure out the solution myself
@dohunkim2922
@dohunkim2922 Год назад
First thing that came to my mind when I saw this question was using two pointer. I tried so but failed. Is it possible to solve this question using two pointer? Also, do I have to memorize that questions like this requires the use of dp? Did you also memorize it or did it come to you intuitively? Thanks
@AsymptoteEducation
@AsymptoteEducation 2 года назад
You have quality content, man. Cheers :)
@VSUKUMARBCE
@VSUKUMARBCE 6 месяцев назад
great explanation Thank You NeetCode I am follow you through out my dsa journey
@referbaru9368
@referbaru9368 Год назад
i have two question 1. is it posible if size of J is more than size of I ? 2. what the LCS of this quest, if I = [a e d a b] and J = [d e b c a g] ? [e d a b] or [d e b a] ?
@AdityaSUnboxings
@AdityaSUnboxings 7 месяцев назад
thank you so much bro u literally answered so much of my confusion.
@HalfJoked
@HalfJoked 2 года назад
Awesome video. We can actually make this O(min(m,n)) space because notice we only have to keep track of 2 rows at any given time. I found the most logical way to write this is to ensure text2 is the smaller variable and base our arrays around that. The reason for that is, we need the bigger string to be the outer loop and the smaller string to be our inner loop in order to make the tabulation work correctly, since we're swapping our rows after each inner loop, and our rows are based around the len(text2). The video solution is perfectly fine, but if you can start with that and get to an ever better space optimization in an interview, it'll look impressive! Passes all test cases. class Solution: def longestCommonSubsequence(self, text1: str, text2: str) -> int: if len(text1) < len(text2): text1, text2 = text2, text1 # text2 is the smaller one, so we base our rows around that cur_row = [0] * (len(text2) + 1) prev_row = [0] * (len(text2) + 1) for i in range(len(text1) - 1, -1, -1): for j in range(len(text2) - 1, -1, -1): if text1[i] == text2[j]: cur_row[j] = 1 + prev_row[j + 1] else: cur_row[j] = max(cur_row[j + 1], prev_row[j]) prev_row, cur_row = cur_row, prev_row return prev_row[0]
@sickboydroid
@sickboydroid 7 месяцев назад
for me the top down approach (or recursive or memoized approach) is more intiuitive. I feel like code is take to me in that way
@mdmasudrana7406
@mdmasudrana7406 2 года назад
You are the best as always. Keep it up, dear.
@prabinlamsal74
@prabinlamsal74 Год назад
I am just starting leetcode and am at about 15 problems only. Please share how many problems you guys have done and some strategies that might be helpful.
@vishwaskotegar5248
@vishwaskotegar5248 10 месяцев назад
blind 75 is the way .. keep at it ...
@DavidDLee
@DavidDLee 2 месяца назад
It's much easier to explain if you start with the full dfs solution. Otherwise, it's hard to give intuition for the the 2D array.
@marchaeldialde
@marchaeldialde 2 месяца назад
What application or software you used here? Thank you
@arkady767
@arkady767 4 месяца назад
Its quite unclear to me, how am i even supposed to understand this is a 2D DP problem during the interview. It would be really helpful if you would go into the solution by following some kind of decision tree you would normally do for other DP problem and explain how that come to be a 2D DP table problem.
@anupamarao3783
@anupamarao3783 26 дней назад
would it work if dp is of dimensions [2][j+1] ? because we only need i+1 th row to calculate dp[i][j]! (j is length of second string).
@tomaparaschiv930
@tomaparaschiv930 3 месяца назад
what are the space and time complexities for this way of solving the problem? thank you
@tarunnarayanan1513
@tarunnarayanan1513 Год назад
This was so well explained! thank you so much.
@nikhilaradhya4088
@nikhilaradhya4088 Месяц назад
You can bring it down to O(COLS) space complexity
@dannggg
@dannggg Год назад
if anyone has a lot of trouble understanding still this other video actually explains it easier in my opinion ru-vid.com/video/%D0%B2%D0%B8%D0%B4%D0%B5%D0%BE-NnD96abizww.html
@switchyard
@switchyard 2 года назад
Lord save us if this is one of the problems we get in an interview and none of the hints make sense. At least when I'm stuck on comparison of two string problem, I always try exploring 2D comparisons
@promethesured
@promethesured 8 месяцев назад
I dont understand why most solutions have the intuition to start at the end of both strings and work back up to [0, 0]. It works either way, and to me it just made sense to start at the top left and end at the bottom right -- why does everyone intuit the other way?
@pranaygawas709
@pranaygawas709 10 месяцев назад
Hi is there is video where you solve this problem but we have to give the actual longest common subsequence?
@moeenkamali1288
@moeenkamali1288 5 месяцев назад
thanks for great tuts. i have a question. i can understand how algorithm work and follow up with it but after a while i figure out that i could not solve it before watching the the solution. i need to be able to solve it from ground up. with no primer knowledge. and that gives the answer that the first person has solved this problem used his long background on math and DP to solve it. so in general learning these algorithms means memorizing them as without knowing the base science its just a trick.
@bulbuliko444
@bulbuliko444 2 года назад
Awsome explanation!
@suhailmahmoud2401
@suhailmahmoud2401 7 месяцев назад
Great explanation, THANK YOU.
@thetechies2259
@thetechies2259 Год назад
when use dp = [[0]*(len(text2)+1)]*(len(text1)+1) for creating 2d array then in some case it fail , but i am not getting why it fail in some cases.
@drakegao816
@drakegao816 2 года назад
Hi, how do I know when the problem is needed for a 2D grid dynamic programming? Thanks.
@nayandhabarde
@nayandhabarde Год назад
Every problem in 2d dynamic programming set has a different approach. I am finding it hard to solve problem by myself without any hint or looking into the solution. Any suggestion how do i improve it for this?
@kbillore28
@kbillore28 Месяц назад
Superb explanation
@Eddie-um6cw
@Eddie-um6cw 2 года назад
what is your drawing software that u use for teach us ?
@Oleg86F
@Oleg86F Год назад
How it's possible to come up with such elegant solution directly at the interview without being genius and seeing the problem for the first time? )))))))
@nadeenmoreb1681
@nadeenmoreb1681 Год назад
Thank you I finally understand it ❤
@junjason4114
@junjason4114 Год назад
Here is my bottom up solution: ```python class Solution: def longestCommonSubsequence(self, text1: str, text2: str) -> int: memo = defaultdict(int) for i in range(len(text1)): for j in range(len(text2)): if text1[i] == text2[j]: memo[(i, j)] = memo[(i - 1, j - 1)] + 1 else: memo[(i, j)] = max(memo[(i - 1, j)], memo[(i, j -1)]) return memo[i, j] ```
@idobooks909
@idobooks909 3 дня назад
Better than a Uni course in Algorithms.
@syafiq9095
@syafiq9095 Год назад
Can anyone explain to me why when the two alphabet does not match, we take the max of to the right and 1 cell below?
@NitinSinghMinVlogs
@NitinSinghMinVlogs 2 года назад
damn man, it's soo good.
@tyro-mb3cv
@tyro-mb3cv 7 месяцев назад
How is this a medium and not a hard 😢
@audioplatform6299
@audioplatform6299 4 месяца назад
I would categorize it as very very hard
@karthiksuryadevara2546
@karthiksuryadevara2546 2 месяца назад
The 2 d approach is hard to grasp, if you think in a recursive or map a decision tree in your mind it will be much easier
@athul.7744
@athul.7744 2 месяца назад
A useful way to think about that is, this kind of question needs to feel like a medium to you to know that you're at the level required to solve this question in an interview. So that's how much you have to improve. Just keep practicing and you'll find that noticing the patterns gets easier over time.
@abhijeetshrivastava1175
@abhijeetshrivastava1175 10 месяцев назад
Nicely explained.
Далее
10 Math Concepts for Programmers
9:32
Просмотров 1,9 млн
How I would learn Leetcode if I could start over
18:03
Просмотров 501 тыс.
LeetCode was HARD until I Learned these 15 Patterns
13:00
Cursor Is Beating VS Code (...by forking it)
18:00
Просмотров 93 тыс.
Premature Optimization
12:39
Просмотров 804 тыс.